
$include (c8051f340.inc)                  ; Include register definition file

;-----------------------------------------------------------------------------
; EQUATES
;-----------------------------------------------------------------------------

CLK         equ P0.0
DATOS       equ P0.1
RESET				equ P0.3
BUSDATOS	  equ P1
BUSDIR			equ P2


; Scan codes (set 3)
SC_F1					equ 07h
ESC					equ 08h
TAB					equ 0dh
BSLASH			equ 0eh
F2					equ 0fh
LCONTROL		equ 11h
LMAYUS			equ 12h
BLMAYUS			equ 14h
SC_Q				equ 15h
SC_1		equ 16h
F3			equ 17h
LALT		equ 19h
SC_Z		equ 1ah
SC_S		equ 1bh
SC_A		equ 1ch
SC_W		equ 1dh
SC_2		equ 1eh
F4			equ 1fh
SC_C		equ 21h
SC_X		equ 22h
SC_D		equ 23h
SC_E		equ 24h
SC_4		equ 25h
SC_3		equ 26h
F5			equ 27h
ESPACIO		equ 29h
SC_V		equ 2ah
SC_F		equ 2bh
SC_T		equ 2ch
SC_R		equ 2dh
SC_5		equ 2eh
F6			equ 2fh
SC_N		equ 31h
SC_B		equ 32h
SC_H		equ 33h
SC_G		equ 34h
SC_Y		equ 35h
SC_6		equ 36h
F7			equ 37h
RALT		equ 39h
SC_M		equ 3ah
SC_J		equ 3bh
SC_U		equ 3ch
SC_7		equ 3dh
SC_8		equ 3eh
F8			equ 3fh
COMA		equ 41h
SC_K		equ 42h
SC_I		equ 43h
SC_O		equ 44h
SC_0		equ 45h
SC_9		equ 46h
F9			equ 47h
PUNTO		equ 49h
MENOS		equ 4ah
SC_L		equ 4bh
SC_ENNE		equ 4ch
SC_P		equ 4dh
APOST		equ 4eh
F10			equ 4fh
LCORCH		equ 54h
ADMIR		equ 55h
F11			equ 56h
PRTSCR		equ 57h
RCONTROL		equ 58h
RMAYUS		equ 59h
INTRO		equ 5ah
RCORCH		equ 5bh
CEDILLA		equ 5ch
F12			equ 5eh
BLDESP		equ 5fh
ABAJO		equ 60h
IZQUIERDA	equ 61h
PAUSA		equ 62h
ARRIBA		equ 63h
SUPR		equ 64h
FIN			equ 65h
BACKSPACE	equ 66h
INS			equ 67h
KP1			equ 69h
DERECHA		equ 6ah
KP4			equ 6bh
KP7			equ 6ch
PGABAJO		equ 6dh
INICIO		equ 6eh
PGARRIBA	equ 6fh
KP0			equ 70h
KPPUNTO		equ 71h
KP2			equ 72h
KP5			equ 73h
KP6			equ 74h
KP8			equ 75h
BLNUM		equ 76h
KPBARRA		equ 77h
KPINTRO		equ 79h
KP3			equ 7ah
KPMAS		equ 7ch
KP9			equ 7dh
KPASTERISCO	equ 7eh
KPMENOS		equ 84h
LWINDOWS	equ 8bh
RWINDOWS	equ 8ch
APPS		equ 8dh


; ---------------------------------------------------------
; EQU's para las definiciones de las teclas en el Spectrum
; ---------------------------------------------------------


; LIT no est soportado por el A51, as que usamos #define, que s est soportado.

#define SP_1 		1,00001b
#define SP_2		1,00010b
#define SP_3		1,00100b
#define SP_4		1,01000b
#define SP_5		1,10000b

#define SP_Q		2,00001b
#define SP_W		2,00010b
#define SP_E		2,00100b
#define SP_R		2,01000b
#define SP_T		2,10000b

#define SP_A		3,00001b
#define SP_S		3,00010b
#define SP_D		3,00100b
#define SP_F		3,01000b
#define SP_G		3,10000b

#define SP_0		4,00001b
#define SP_9		4,00010b
#define SP_8		4,00100b
#define SP_7		4,01000b
#define SP_6		4,10000b

#define SP_P		5,00001b
#define SP_O		5,00010b
#define SP_I		5,00100b
#define SP_U		5,01000b
#define SP_Y		5,10000b

#define CAPS		6,00001b
#define SP_Z		6,00010b
#define SP_X		6,00100b
#define SP_C		6,01000b
#define SP_V		6,10000b

#define ENTER		7,00001b
#define SP_L		7,00010b
#define SP_K		7,00100b
#define SP_J		7,01000b
#define SP_H		7,10000b

#define SPACE		8,00001b
#define SYMBOL	8,00010b
#define SP_M		8,00100b
#define SP_N		8,01000b
#define SP_B		8,10000b

; ----------------------------------------------------------------------------
; MACROS
; ----------------------------------------------------------------------------

DefTecla 	macro scan,smf,valor
          local Pulsada,NoesEste

          cjne R6,#&scan,NoesEste

					mov A,Soltada
					jz Pulsada

					mov A,Sm&smf
					orl A,#&valor
					mov Sm&smf,A
					ljmp FinScans

Pulsada:  mov A,#&valor
          cpl A
					mov R6,A
					mov A,Sm&smf
					anl A,R6
					mov Sm&smf,A
					ljmp FinScans
					
NoesEste:
          endm 


DefTecla2	macro scan,smf,valor,smf2,valor2
          local Pulsada,NoesEste

          cjne R6,#&scan,NoesEste

					mov A,Soltada
					jz Pulsada

					mov A,Sm&smf
					orl A,#&valor
					mov Sm&smf,A

					mov A,Sm&smf2
					orl A,#&valor2
					mov Sm&smf2,A

					ljmp FinScans

Pulsada:  mov A,#&valor
          cpl A
					mov R6,A
					mov A,Sm&smf
					anl A,R6
					mov Sm&smf,A

					mov A,#&valor2
          cpl A
					mov R6,A
					mov A,Sm&smf2
					anl A,R6
					mov Sm&smf2,A

					ljmp FinScans
					
NoesEste:
          endm 

IncSemif	macro semf
					local NoIncEsta
          rrc A							; 1
					jc NoIncEsta			; 3

					xch A,R5					; 1
					mov A,Sm&semf			; 2
					anl A,R6					; 1
					mov R6,A					; 1
					xch A,R5					; 1
NoIncEsta:
					endm							; Total en el peor caso: 10 ciclos

;-----------------------------------------------------------------------------
; SIMBOLOS EXTERNOS
;-----------------------------------------------------------------------------
extrn code (Init_Device)

;-----------------------------------------------------------------------------
; SEGMENTO DE DATOS
;-----------------------------------------------------------------------------

            dseg at 30h   ; Segmento de datos RAM
LastK:      ds 1          ; Ultimo SCAN KEY
Soltada:    ds 1          ; Pulsado o soltado
Ctrl:				ds 1          ; CTRL pulsada
Alt:        ds 1					; ALT pulsada
Del:	  		ds 1					; SUPR pulsada
Mayus:			ds 1					; MAYUS pulsada
ModoJoy:    ds 1          ; Indica si hemos pasado a modo joystick Sinclair
Leds:       ds 1					; Estado de los leds del teclado

Sm1:        ds 1
Sm2:        ds 1
Sm3:        ds 1
Sm4:        ds 1
Sm5:        ds 1
Sm6:        ds 1
Sm7:        ds 1
Sm8:        ds 1

;-----------------------------------------------------------------------------
; RESET and INTERRUPT VECTORS
;-----------------------------------------------------------------------------

            ; Reset Vector
            cseg at 0
            ljmp Main                     

						; INT0
						cseg at 03h
            inc R7

  					cjne R7,#1, NoBitStart
						mov R6,#0
						jnb DATOS, StartVal
						mov R7,#0
StartVal:		mov R5,#0
            reti

NoBitStart: cjne R7,#0ah, NoPar
            inc R5
						jb DATOS, NoDecR5
						dec R5
NoDecR5:  	reti

NoPar:      cjne R7,#0bh, NoBitStop
            jnb DATOS, NoDatoVal
						xch A,R5
						anl A,#1
						xch A,R5
						cjne R5,#1, NoDatoVal

            ; En R6 tenemos nuestro dato!!
						; Hacer lo que sea con l

            mov Soltada,#0
            mov R5, LastK
            cjne R5, #0f0h, TeclaPul
						mov Soltada,#1

TeclaPul:	  mov LastK,R6

						cjne R6,#0aah, NoACKRst
						acall Init_Teclado
						sjmp FinRec

NoACKRst:   clr CLK    ; inhibo la comunicacin mientras estoy procesando...
            acall DecoKEY
						setb CLK

FinRec:

NoDatoVal:	mov R7,#0
						reti

NoBitStop:  setb C
            inc R5
            jb DATOS,SigBit
						clr C
						dec R5
SigBit:     xch A,R6
            rrc A
            xch A,R6

						reti


;-----------------------------------------------------------------------------
; CODE SEGMENT
;-----------------------------------------------------------------------------

Teclado     segment  CODE

            rseg     Teclado              ; Switch to this code segment.
            using    0                    ; Specify register bank for the
                                          ; following program code.
Main:
            ; Disable the WDT.
            anl   PCA0MD, #NOT(040h)      ; clear Watchdog Enable bit

            mov R7,#0                     ; R7 = contador bits teclado
            mov R6,#0                     ; R6 = ultimo valor leido del teclado o valor a transmitir
						mov R5,#0                     ; R5 = cuenta los 'unos' leidos para la paridad

            ; Iniciamos variables
						mov LastK,#0
						mov Soltada,#0
						mov Ctrl,#0
						mov Alt,#0
						mov Supr,#0
						mov Mayus,#0
						mov ModoJoy,#0

            ; Iniciamos semifilas al valor "ninguna tecla pulsada"
						mov Sm1,#0ffh
						mov Sm2,#0ffh
						mov Sm3,#0ffh
						mov Sm4,#0ffh
						mov Sm5,#0ffh
						mov Sm6,#0ffh
						mov Sm7,#0ffh
						mov Sm8,#0ffh

						lcall Init_Device

						mov BUSDATOS, #0ffh
						mov BUSDIR,#0ffh
						setb CLK
						setb DATOS
						setb RESET

						lcall InitXRAM
           
            mov R6,#0ffh    ; Reset software al teclado
						acall Transmitir

						; Bucle principal: lee y actualiza constantemente los bits D0 a D4 en el bus de datos del
						; teclado en la ULA. En el F343 esto lleva alrededor de 210 nanosegundos por actualizacin.
Bucle:      mov R1,BUSDIR					; 2 c.
						movx A,@R1				 		; 3 c.
						mov BUSDATOS,A				; 2 c.
						sjmp Bucle						; 3 c.

; --------------------------------------------------------------------------------
; RUTINA PARA ENVIAR UN BYTE AL TECLADO.
; ESTA RUTINA INHIBE TODAS LAS INTERRUPCIONES Y PONE UN #FF EN EL BUS DE DATOS POR SI OCURRE UNA LECTURA DE LA ULA
; MIENTRAS SE ENVIA EL COMANDO AL TECLADO.
; R6 contiene el dato a enviar.
; R7 es el contador de bits
; R5 es el contador de unos para la paridad
; --------------------------------------------------------------------------------

Transmitir: anl IE, #NOT(080h)    ; Sin interrupciones
            mov BUSDATOS, #0ffh
						mov R5,#0             ; Contador de 'unos' para la paridad
						mov R7,#8

            ; 1. Poner CLK bajo durante al menos 160 us, y DATOS unos 30us despus de bajar CLK
						setb DATOS
						clr CLK

						mov A,#30
            acall uDelay

						clr DATOS

						mov A,#130
            acall uDelay

            ; 2. Liberar reloj
            setb CLK

            ; 3a. Esperar pulso bajo y enviar un 0 (bit de start)
PulsoBajo0:	jb CLK, PulsoBajo0
PulsoAlto0: jnb CLK, PulsoAlto0

						; 3b. Esperar pulso bajo e ir enviando bits
PulsoBajo1:	jb CLK, PulsoBajo1
            mov A,R6
						anl A,#1
						cjne A,#0, Tran1
						clr DATOS
						sjmp SigueTr

Tran1:      setb DATOS
            inc R5

SigueTr:    mov A,R6
            rr A
						mov R6,A

PulsoAlto1: jnb CLK, PulsoAlto1

            djnz R7, PulsoBajo1

            ; 4. Enviar paridad
PulsoBajo2:	jb CLK, PulsoBajo2
            mov A,R5
            cpl A
						anl A,#1
						jz TrPar0
						setb DATOS
						sjmp SigueTr2
TrPar0:     clr DATOS
SigueTr2:   
PulsoAlto2: jnb CLK, PulsoAlto2
            
            ; 5. Liberar datos
						setb DATOS

            ; 6. Esperar nivel bajo en datos
PBajoDatos: jb DATOS, PBajoDatos
             
						; 7. Esperar nivel bajo en reloj
PulsoBajo3: jb CLK, PulsoBajo3

            ; 8. Esperar a que reloj y datos suban
PulsoFinal:	mov A,P0
						anl A,#3
						cjne A,#3, PulsoFinal
            
						clr IE0  ; Limpiar bandera de interrupcion pendiente por si acaso
						orl IE, #080h   ; Interrupciones habilitadas de nuevo
						ret
; --------------------------------------------------------------------------------
; Rutina que espera los us que especifiquemos
; Entrada: A es el numero de us a esperar
; Esta rutina est calibrada para un reloj de 48MHz
; --------------------------------------------------------------------------------
uDelay:     nop
            nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
            nop
						nop
            nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
            nop
						dec A
						jnz uDelay
						ret

; --------------------------------------------------------------------------------
; Rutina que espera los ms que especifiquemos
; Entrada: A es el numero de ms a esperar
; --------------------------------------------------------------------------------
mDelay:     xch A,R2
            mov A,#200
						acall uDelay
            mov A,#200
						acall uDelay
            mov A,#200
						acall uDelay
            mov A,#200
						acall uDelay
            mov A,#200
						acall uDelay
            xch A,R2
						dec A
						jnz mDelay
						ret

; --------------------------------------------------------------------------------
; Esperar a respuesta del teclado
; --------------------------------------------------------------------------------
WaitK:      mov LastK,#0
BucWT:      mov A,LastK
            jz BucWT
						ret

; --------------------------------------------------------------------------------
; Rutina para inicializar el teclado
; Pone el modo scan 3 y activa Bloq Num.
; Se activa desde el gestor de interrupciones, en respuesta a la seal de RESET
; --------------------------------------------------------------------------------
Init_Teclado:
            ; SCAN SET 3
            mov R6,#0f0h
						acall Transmitir
						mov R6,#3
						acall Transmitir

            ; MAKE / BREAK para todas las teclas
						mov R6,#0f8h
						acall Transmitir

            mov A,#0
						acall uDelay  ; El comando anterior es un poco lento, as que esperamos un poco

            ; BLOQ NUM activado
					  mov R6,#0edh
					  acall Transmitir
					  mov R6,#2
					  acall Transmitir
						mov Leds,#2
						mov ModoJoy,#0

					  ret
; --------------------------------------------------------------------------------
; Rutina principal de decodificacin de tecla AT -> Speccy
; LastK = tecla a decodificar
; Soltada = estado de la pulsacin
; --------------------------------------------------------------------------------
DecoKEY:    ;Primero se procesan las teclas especiales y se comprueban las combinanciones especiales

            mov R6,LastK
						cjne R6, #LCONTROL, NoesLCtrl
						mov A, Soltada
						xrl A,#1
						mov Ctrl,A
						sjmp FinEspeciales

NoesLCtrl:  cjne R6,#RCONTROL, NoesRCtrl
						mov A, Soltada
						xrl A,#1
						mov Ctrl,A
						sjmp FinEspeciales

NoesRCtrl:  cjne R6,#LALT, NoesLAlt
						mov A, Soltada
						xrl A,#1
            mov Alt,A
						sjmp FinEspeciales
						
NoesLAlt:   cjne R6,#RALT, NoesRAlt
						mov A, Soltada
						xrl A,#1
            mov Alt,A
						sjmp FinEspeciales
						
NoesRAlt:   cjne R6,#SUPR, NoesSupr1
						mov A, Soltada
						xrl A,#1
            mov Del,A
						sjmp FinEspeciales
						
NoesSupr1:	cjne R6,#KPPUNTO, NoesSupr2
						mov A, Soltada
						xrl A,#1
            mov Del,A
						sjmp FinEspeciales					
						
NoesSupr2:  cjne R6,#LMAYUS, NoesLMayus
						mov A, Soltada
						xrl A,#1
            mov Mayus,A
						sjmp FinEspeciales
						
NoesLMayus: cjne R6,#RMAYUS, NoesRMayus
						mov A, Soltada
						xrl A,#1
            mov Mayus,A
						sjmp FinEspeciales

NoesRMayus: cjne R6,#BLDESP, NoesBlDesp
            mov A,Soltada
						jnz NoesBlDesp
            mov A,ModoJoy
						cpl A
						mov ModoJoy,A
					  mov R6,#0edh
					  acall Transmitir
						mov A,Leds
						xrl A,#1
						mov Leds,A
					  mov R6,A
					  acall Transmitir
						mov R6,LastK
						sjmp FinEspeciales

NoesBlDesp:

FinEspeciales:
            mov A,Ctrl
						anl A,Alt
						anl A,Del
						jz NoReset

						clr RESET
						mov A,#0
						call uDelay     ; Pulso de RESET de unos 250 us al Spectrum
						setb RESET
						mov Ctrl,#0
						mov Alt,#0
						mov Del,#0
						sjmp FinComb

NoReset:

FinComb:    DefTecla2 ESC,CAPS,SPACE
            DefTecla2 TAB,CAPS,SYMBOL
						DefTecla2 F2,CAPS,SP_1
						DefTecla2 BSLASH,SYMBOL,SP_D
            DefTecla2 BLMAYUS,CAPS,SP_2

						DefTecla2 BACKSPACE,CAPS,SP_0

						DefTecla  SC_Q,SP_Q
						DefTecla  SC_W,SP_W
						DefTecla  SC_E,SP_E
						DefTecla  SC_R,SP_R
						DefTecla  SC_T,SP_T
						DefTecla  SC_Y,SP_Y
						DefTecla  SC_U,SP_U
						DefTecla  SC_I,SP_I
						DefTecla  SC_O,SP_O
						DefTecla  SC_P,SP_P

						DefTecla  SC_A,SP_A
						DefTecla  SC_S,SP_S
						DefTecla  SC_D,SP_D
						DefTecla  SC_F,SP_F
						DefTecla  SC_G,SP_G
						DefTecla  SC_H,SP_H
						DefTecla  SC_J,SP_J
						DefTecla  SC_K,SP_K
						DefTecla  SC_L,SP_L
						DefTecla2 CEDILLA,SYMBOL,SP_P
						DefTecla  INTRO,ENTER

						DefTecla  SC_Z,SP_Z
						DefTecla  SC_X,SP_X
						DefTecla  SC_C,SP_C
						DefTecla  SC_V,SP_V
						DefTecla  SC_B,SP_B
						DefTecla  SC_N,SP_N
						DefTecla  SC_M,SP_M
						DefTecla  ESPACIO,SPACE

						DefTecla  KP0,SP_0
						DefTecla  KP1,SP_1
						DefTecla  KP2,SP_2
						DefTecla  KP3,SP_3
						DefTecla  KP4,SP_4
						DefTecla  KP5,SP_5
						DefTecla  KP6,SP_6
						DefTecla  KP7,SP_7
						DefTecla  KP8,SP_8
						DefTecla  KP9,SP_9
						DefTecla2 KPBARRA,SYMBOL,SP_V
						DefTecla2 KPASTERISCO,SYMBOL,SP_B
						DefTecla2 KPMENOS,SYMBOL,SP_J
						DefTecla2 KPMAS,SYMBOL,SP_K
						DefTecla2 KPPUNTO,SYMBOL,SP_M
						DefTecla  KPINTRO,ENTER

						mov R0,Mayus
						cjne R0,#0,PonShift
						lcall SinShift
						ajmp FinShift
PonShift:		lcall ConShift
FinShift:

						mov R0,ModoJoy
						cjne R0,#0,PonModoJoy
						lcall PonCursores
						ajmp FinModoJoy
PonModoJoy: lcall PonSinclair
FinModoJoy:

FinScans:   
						mov R0,#0
BucFillX: 	mov R6,#0ffh
						mov A,R0
						IncSemif 1      ; CUIDADO! Esto es porque los cables estn as.
						IncSemif 2
						IncSemif 3
						IncSemif 4
						IncSemif 5
						IncSemif 6
						IncSemif 7
						IncSemif 8
						mov A,R6
						movx @R0,A
						inc R0
						cjne R0,#0ffh,BucFillX
            ret

PonCursores:
						DefTecla2 ARRIBA,CAPS,SP_7
						DefTecla2 ABAJO,CAPS,SP_6
						DefTecla2 IZQUIERDA,CAPS,SP_5
						DefTecla2 DERECHA,CAPS,SP_8
            DefTecla  LCONTROL,CAPS
            DefTecla  RCONTROL,SYMBOL
						ret
						
PonSinclair:
						DefTecla ARRIBA,SP_6
						DefTecla ABAJO,SP_7
						DefTecla DERECHA,SP_8
						DefTecla IZQUIERDA,SP_9
						DefTecla LCONTROL,SP_0
						DefTecla RCONTROL,SP_0
						ret						            

SinShift:   DefTecla  SC_1,SP_1
						DefTecla  SC_2,SP_2
						DefTecla  SC_3,SP_3
						DefTecla  SC_4,SP_4
						DefTecla  SC_5,SP_5
						DefTecla  SC_6,SP_6
						DefTecla  SC_7,SP_7
						DefTecla  SC_8,SP_8
						DefTecla  SC_9,SP_9
						DefTecla  SC_0,SP_0
						DefTecla2 APOST,SYMBOL,SP_7
						DefTecla2 ADMIR,SYMBOL,SP_1
						DefTecla2 LCORCH,SYMBOL,SP_Y
						DefTecla2 RCORCH,SYMBOL,SP_K
						DefTecla2 COMA,SYMBOL,SP_N
						DefTecla2 PUNTO,SYMBOL,SP_M
						DefTecla2 MENOS,SYMBOL,SP_J
						ret

ConShift:   DefTecla2 SC_1,SYMBOL,SP_1
						DefTecla2 SC_2,SYMBOL,SP_P
						DefTecla2 SC_3,SYMBOL,SP_3
						DefTecla2 SC_4,SYMBOL,SP_4
						DefTecla2 SC_5,SYMBOL,SP_5
						DefTecla2 SC_6,SYMBOL,SP_6
						DefTecla2 SC_7,SYMBOL,SP_V
						DefTecla2 SC_8,SYMBOL,SP_8
						DefTecla2 SC_9,SYMBOL,SP_9
						DefTecla2 SC_0,SYMBOL,SP_L
						DefTecla2 APOST,SYMBOL,SP_C
						DefTecla2 LCORCH,SYMBOL,SP_H
						DefTecla2 RCORCH,SYMBOL,SP_B
						DefTecla2 COMA,SYMBOL,SP_O
						DefTecla2 PUNTO,SYMBOL,SP_Z
						DefTecla2 MENOS,SYMBOL,SP_0
						ret

InitXRAM:   mov R0,#00h
            mov A,#0ffh
BucInitX:   movx @R0,A
            inc R0
						cjne R0,#0,BucInitX

END

